(**************************************************************************)
(*                                                                        *)
(*  Copyright (C) 2010-2011                                               *)
(*    François Bobot                                                     *)
(*    Jean-Christophe Filliâtre                                          *)
(*    Claude Marché                                                      *)
(*    Andrei Paskevich                                                    *)
(*                                                                        *)
(*  This software is free software; you can redistribute it and/or        *)
(*  modify it under the terms of the GNU Library General Public           *)
(*  License version 2.1, with the special exception on linking            *)
(*  described in file LICENSE.                                            *)
(*                                                                        *)
(*  This software is distributed in the hope that it will be useful,      *)
(*  but WITHOUT ANY WARRANTY; without even the implied warranty of        *)
(*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.                  *)
(*                                                                        *)
(**************************************************************************)

(*i camlp4deps: "parsing/grammar.cma" i*)

open Whytac

open Pcoq
let h_Why s =
  Refiner.abstract_extended_tactic "Why" [Genarg.in_gen Genarg.wit_string s]
    (whytac s)
let _ =
  try
    let _ =
      Tacinterp.add_tactic "Why"
        (function
           [s] when Genarg.genarg_tag s = Genarg.StringArgType && true ->
             let s = Genarg.out_gen Genarg.wit_string s in whytac s
         | _ -> failwith "Tactic extension: cannot occur")
    in
    List.iter
      (fun s ->
         Tacinterp.add_primitive_tactic s
           (Tacexpr.TacAtom
              (Util.dummy_loc, Tacexpr.TacExtend (Util.dummy_loc, s, []))))
      []
  with e -> Pp.pp (Cerrors.explain_exn e)
let _ =
  Egrammar.extend_tactic_grammar "Why"
    [[Egrammar.TacTerm "why";
      Egrammar.TacNonTerm
        (Util.dummy_loc,
         (Gramext.Snterm (Pcoq.Gram.Entry.obj Prim.string),
          Genarg.StringArgType),
         Some "s")]]
let _ =
  List.iter Pptactic.declare_extra_tactic_pprule
    ["Why", [Genarg.StringArgType], (0, [Some "why"; None])]
